//------------------------------------------------------------------------------
//
//   Greg's Blocks - ContainerSawbench
//
//------------------------------------------------------------------------------

package gcewing.blocks;

import net.minecraft.entity.player.*;
import net.minecraft.inventory.*;
import net.minecraft.item.*;
import net.minecraft.nbt.*;
import net.minecraft.network.play.server.*;
import net.minecraft.tileentity.*;
import net.minecraft.world.*;

public class ContainerSawbench extends BaseContainer {

	TESawbench te;
	
	public static Container create(EntityPlayer player, World world, int x, int y, int z) {
		TileEntity te = world.getTileEntity(x, y, z);
		if (te instanceof TESawbench)
			return new ContainerSawbench(player, (TESawbench)te);
		else
			return null;
	}
	
	public ContainerSawbench(EntityPlayer player, TESawbench te) {
		super(176, 166);
		this.te = te;
		addSlotToContainer(new Slot(te, 0, 26, 19));
		addSlotToContainer(new SlotSawbenchResult(te, 1, 134, 38));
		addPlayerSlots(player, 8, 84);
	}
	
//	@Override
//	public boolean canInteractWith(EntityPlayer player) {
//		return this.te.isUseableByPlayer(player);
//	}

//	/**
//	 * Called to transfer a stack from one inventory to the other eg. when shift clicking.
//	 */
//	 
//	@Override
//	public ItemStack transferStackInSlot(EntityPlayer player, int par1) {
//		// TODO
//		return null;
//	}
	
	public void setSelectedShape(int i) {
		te.setSelectedShape(i);
	}
		
	//
	//   Server
	//
	
	@Override
	public void detectAndSendChanges() {
		for (int i = 0; i < this.inventorySlots.size(); ++i) {
			ItemStack newstack = ((Slot)this.inventorySlots.get(i)).getStack();
			ItemStack oldstack = (ItemStack)this.inventoryItemStacks.get(i);
			if (!ItemStack.areItemStacksEqual(oldstack, newstack))
			{
				oldstack = newstack == null ? null : newstack.copy();
				this.inventoryItemStacks.set(i, oldstack);
				for (Object crafter : crafters) {
					if (crafter instanceof EntityPlayerMP) {
						//System.out.printf("ContainerSawbench.updateCraftingResults: sending %s in slot %d to player\n", newstack, i);
						((EntityPlayerMP)crafter).playerNetServerHandler.sendPacket(
							new S2FPacketSetSlot(windowId, i, newstack));
					}
					else
						((ICrafting)crafter).sendSlotContents(this, i, newstack);
				}
			}
		}
		for (Object crafter : crafters)
			sendStateTo((ICrafting)crafter);
	}

	void sendStateTo(ICrafting crafter) {
		//System.out.printf("ContainerSawbench.sendStateTo: %s; selectedShape = %d\n", crafter, te.selectedShape);
		crafter.sendProgressBarUpdate(this, 0, te.selectedShape);
		crafter.sendProgressBarUpdate(this, 1, te.pendingMaterialUsage ? 1 : 0);
	}
	

	//
	//   Client
	//

	@Override 
	public void putStackInSlot(int i, ItemStack stack) {
		// Slot update packet has arrived from server. Do not trigger crafting behaviour.
		Slot slot = getSlot(i);
		if (slot instanceof SlotSawbench) {
			//System.out.printf("ContainerSawbench.putStackInSlot: %d %s on %s\n", i, stack, te.worldObj);
			((SlotSawbench)slot).updateFromServer(stack);
		}
		else
			super.putStackInSlot(i, stack);
	}

	@Override
	public void updateProgressBar(int i, int value) {
		//System.out.printf("ContainerSawbench.updateProgressBar: %d %d\n", i, value);
		switch (i) {
			case 0: te.selectedShape = value;
			case 1: te.pendingMaterialUsage = value != 0;
		}
	}

}

//------------------------------------------------------------------------------

class SlotSawbench extends Slot {

	TESawbench te;
	int index;

	public SlotSawbench(TESawbench te, int index, int x, int y) {
		super(te, index, x, y);
		this.te = te;
		this.index = index;
	}
	
	void updateFromServer(ItemStack stack) {
		te.inventory.setInventorySlotContents(index, stack);
	}

}

//------------------------------------------------------------------------------

class SlotSawbenchResult extends SlotSawbench {

	public SlotSawbenchResult(TESawbench te, int index, int x, int y) {
		super(te, index, x, y);
	}

	@Override
	public boolean isItemValid(ItemStack newstack) {
		return false;
	}

}
	
	