//------------------------------------------------------------------------------
//
//   Greg's Blocks - GuiSawbench
//
//------------------------------------------------------------------------------

package gcewing.blocks;

import org.lwjgl.opengl.GL11;

import net.minecraft.client.gui.inventory.*;
import net.minecraft.client.renderer.*;
import net.minecraft.entity.player.*;
import net.minecraft.tileentity.*;
import net.minecraft.world.*;
import net.minecraft.util.StatCollector;

public class GuiSawbench extends GuiContainer {

	TESawbench te;
	
	public static GuiSawbench create(EntityPlayer player, World world, int x, int y, int z) {
		TileEntity te = world.getTileEntity(x, y, z);
		if (te instanceof TESawbench)
			return new GuiSawbench(player, (TESawbench)te);
		else
			return null;
	}
	
	public GuiSawbench(EntityPlayer player, TESawbench te) {
		super(new ContainerSawbench(player, te));
		this.te = te;
	}
	
	@Override
	protected void drawGuiContainerForegroundLayer(int par1, int par2) {
		String title = StatCollector.translateToLocal("text.gcewing_blocks:sawbench");
		fontRendererObj.drawString(title, 7, 7, 4210752);
		beginDrawing();
		drawShapeMenu();
		drawShapeSelection();
		endDrawing();
	}
	
	void drawShapeMenu() {
		GL11.glPushMatrix();
		GL11.glTranslatef(61, 21, 0);
		GL11.glScalef(0.25F, 0.25F, 1.0F);
		bindTexture("shapes.png");
		drawTexturedModalRect(0, 0, 0, 0, 3*72, 3*72);
		GL11.glPopMatrix();
		bindTexture("gui_sawbench.png");
	}
		
	void drawShapeSelection() {
		int i = te.selectedShape;
		int row = i / 3;
		int col = i % 3;
		int x = 61 + 18 * col;
		int y = 21 + 18 * row;
		//System.out.printf("GuiSawbench.drawShapeSelection: sel=%d x=%d y=%d\n", i, x, y);
		drawTexturedModalRect(x, y, 176, 0, 18, 18);
	}

	@Override
	protected void drawGuiContainerBackgroundLayer(float par1, int par2, int par3) {
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		bindTexture("gui_sawbench.png");
		int x0 = (this.width - this.xSize) / 2;
		int y0 = (this.height - this.ySize) / 2;
		drawTexturedModalRect(x0, y0, 0, 0, this.xSize, this.ySize);
	}
	
	void beginDrawing() {
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		bindTexture("gui_sawbench.png");
	}
	
	void endDrawing() {
	}

	void bindTexture(String name) {
		//RenderEngine re = this.mc.renderEngine;
		//String path = GregsBlocks.textureDir + name;
		//re.bindTexture(path);
		GregsBlocks.mod.client.bindTexture("gui/" + name);
	}

	protected void mouseClicked(int x, int y, int btn) {
		//System.out.printf("GuiSawbench.mouseClicked: %d, %d, %d\n", x, y, btn);
		int x0 = (this.width - this.xSize) / 2;
		int y0 = (this.height - this.ySize) / 2;
		int row = (y - y0 - 15) / 18;
		int col = (x - x0 - 61) / 18;
		int i = row * 3 + col;
		if (row >= 0 && row < 3 && col >= 0 && col < 3) {
			if (te.getWorldObj().isRemote)
				GregsBlocks.channel.sendSawbenchSelectShape(i);
			else
				te.setSelectedShape(i);
			return;
		}
		super.mouseClicked(x, y, btn);
	}

}
